Bug 987278 - fail to transfer any data between host and guest with virtio serial through UDP option
fail to transfer any data between host and guest with virtio serial through U...
Status: CLOSED WORKSFORME
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: qemu-kvm (Show other bugs)
7.0
Unspecified Unspecified
medium Severity medium
: rc
: ---
Assigned To: Amit Shah
Virtualization Bugs
:
Depends On: 985214 1121579 1174102
Blocks:
  Show dependency treegraph
 
Reported: 2013-07-23 03:06 EDT by Sibiao Luo
Modified: 2014-12-15 01:52 EST (History)
15 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 985214
Environment:
Last Closed: 2013-11-26 09:34:47 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Comment 1 Sibiao Luo 2013-07-23 03:09:42 EDT
host info:
3.10.0-0.rc7.64.el7.x86_64
qemu-kvm-1.5.1-2.el7.x86_64
guest info:
3.10.0-0.rc7.64.el7.x86_64
Comment 3 Gerd Hoffmann 2013-11-26 09:34:47 EST
udp chardev works for me.

Terminal #1:
nc -4 -u -l 12345

Terminal #2: 
qemu-kvm  -chardev udp,id=test,port=12345,localport=54321,ipv4 \
     -device isa-debugcon,iobase=0x402,chardev=test

seabios log messages show up in Terminal #1 just fine.

Now and then there is a piece missing.  But note that unlike TCP the UDP protocol doesn't make any guaranties whatsoever.  In case buffers are full packets are simply dropped and lost.  So this is normal behavior.  Packets can also be reordered.

Note that both qemu+netcat are forced into ipv4 mode to make sure they speak the same protocol.

Also note that I'm explicitly setting localport to avoid a random port being picked.  This allows to keep netcat in terminal #1 running while starting qemu multiple times even though netcat will only accept packets from a single peer address.

Final note: The UDP protocol is stateless.  There is no "connected" and "disconnected" state.  Consequently the UDP chardev backend doesn't send open/close chardev events.  Which virtio-serial might depend on to work correctly.  Amit?

Bottom line:  Testing the udp chardev with anything which requires a reliable stream is bogus in the first place.  The only remotely useful use case for the udp chardev backend I can think of is to send guest output to a remote syslog server (which traditionally listens on udp port 514).
Comment 4 Ronen Hod 2013-11-26 10:05:51 EST
(In reply to Gerd Hoffmann from comment #3)
> Bottom line:  Testing the udp chardev with anything which requires a
> reliable stream is bogus in the first place.  The only remotely useful use
> case for the udp chardev backend I can think of is to send guest output to a
> remote syslog server (which traditionally listens on udp port 514).

I think that the right test is to validate that data is received. If some/many of the packets are lost, this is OK, as long as many packets are also received.
Comment 5 Amit Shah 2013-11-27 05:03:32 EST
(In reply to Gerd Hoffmann from comment #3)
> Final note: The UDP protocol is stateless.  There is no "connected" and
> "disconnected" state.  Consequently the UDP chardev backend doesn't send
> open/close chardev events.  Which virtio-serial might depend on to work
> correctly.  Amit?

Yep, good point.

Note You need to log in before you can comment on or make changes to this bug.